<script setup lang="ts">
interface Attribute {
  header: string;
  value: any;
}

const props = withDefaults(
  defineProps<{ attributes: Attribute[]; vertical: boolean }>(),
  {
    vertical: false,
  },
);
</script>

<template>
  <template v-if="!vertical">
    <div class="text-body-2">
      <template v-for="({ header, value }, idx) in props.attributes" :key="idx">
        <span class="text-medium-emphasis">
          <slot name="header" :header="header"> {{ header }}: </slot>
        </span>
        <span>
          <slot name="value" :value="value"> {{ value }}</slot>
        </span>
        <template v-if="idx !== props.attributes.length - 1">
          <v-divider vertical class="mx-2 d-inline" />
        </template>
      </template>
    </div>
  </template>
  <template v-else>
    <v-table class="text-body-2">
      <template v-for="({ header, value }, idx) in props.attributes" :key="idx">
        <tr>
          <td style="width: 1px; white-space: nowrap">
            <span class="text-medium-emphasis">
              <slot name="header" :header="header"> {{ header }} </slot>
            </span>
          </td>
          <td style="width: 1px">
            <span class="text-medium-emphasis">&nbsp;:&nbsp;</span>
          </td>
          <td>
            <span>
              <slot name="value" :value="value"> {{ value }} </slot>
            </span>
          </td>
        </tr>
      </template>
    </v-table>
  </template>
</template>

<style scoped>
td {
  vertical-align: top;
}
</style>
